Subject: Re: bug#35691: [bug-guix] remote configure failure due to bad pathnames for crt*.o

From: "Nelson H. F. Beebe" <[email-masked]>
Date: Wed, 15 May 2019 08:27:22 -0600

>> ...
>> >       configure: error: C compiler cannot create executables
>> >       See `config.log' for more details
>> 
>> What does config.log show?
>> 
>> What does guix package --list-installed return?
>> 
>> Please make sure that only gcc-toolchain in your profile, and not gcc.
>> ...

The config.log fragment is

	configure:2095: gcc  -I${prefix}/include  -I${prefix}/include -L/usr/uumath/lib64 -Wl,-rpath,/usr/uumath/lib64 conftest.c  >&5
	ld: cannot find crt1.o: No such file or directory
	ld: cannot find crti.o: No such file or directory
	collect2: error: ld returned 1 exit status

I tried

	guix remove gcc

Same problem.  I then did

	guix remove gcc-toolchain

Same problem: there is still a gcc visible: /u/sy/beebe/.guix-profile/bin/gcc.

The strace output shows that it tries to load .../libcrt1.o, instead of .../lib/crt1.o.

Here is what I find about installed gcc-related packages:

	$ guix package --list-installed |grep gcc
	gccgo   4.9.4   out     /gnu/store/7108fl31hfj9lb4y76g89sxdb43c1wpc-gccgo-4.9.4
	gcc-objc        8.3.0   out     /gnu/store/44r4xl10nmix25bv6bv974r280vc232c-gcc-objc-8.3.0
	gcc-objc++      8.3.0   out     /gnu/store/wqycqqp4almqcmmsj7gys56lyk9girvq-gcc-objc++-8.3.0
	gcc-bootstrap   0       out     /gnu/store/fgarfy5392vz5hik1ag5b8ccv0r4cm01-gcc-bootstrap-0
	gcc-toolchain   9.1.0   out     /gnu/store/aqv6njg05w2yqh8krgrjy0wcbfxb4nn3-gcc-toolchain-9.1.0

Maybe it is related to another problem that I wanted to eventually
raise on a guix list.  Namely, after installing the new GUIX 1.0 VM, I
found that /usr/bin, /usr/sbin, and /sbin do not exist, and /bin
contains only /bin/sh.  Even after numerous "guix install" runs, /bin
continues to have only one entry.

This seems bizarre, because it is long-standing practice that
shell scripts should set PATH to a limited value to avoid
trojan attacks, and things like "/bin/rm foo" should always work.

On your GUIX systems, do you have a reasonably populated /bin?  Ditto
the other three.

For reference, here is the system configuration:

;; This is an operating system configuration generated
;; by the graphical installer.

(use-modules (gnu))
(use-service-modules desktop networking ssh xorg)

(operating-system
  (locale "en_US.utf8")
  (timezone "America/Denver")
  (keyboard-layout
    (keyboard-layout "us" "altgr-intl"))
  (bootloader
    (bootloader-configuration
      (bootloader grub-bootloader)
      (target "/dev/sda")
      (keyboard-layout keyboard-layout)))
  (file-systems
    (cons* (file-system
             (mount-point "/")
             (device
               (uuid "a7e44cea-8fee-4431-9658-59644e18c9ec"
                     'ext4))
             (type "ext4"))
           %base-file-systems))
  (host-name "guix10.vm.math.utah.")
 
  ;; ===========================================================
  ;; [02-May-2019] Utah additions
  ;; After updating this file, run
  ;;	guix system reconfigure /etc/config.scm
  ;; to propagate the changes into assorted system files.
  ;; ===========================================================

;  (groups (cons*    
;	   (user-group (name "beebe") (id 887))
;	   (user-group (name "bowman") (id 888))
;	   (user-group (name "sysstaff") (id 810))))

  (users (cons*
	  (user-account
           (name "x")
           (comment "X")
           (group "users")
           (home-directory "/home/x")
           (supplementary-groups '("wheel" "netdev" "audio" "video")))

	  (user-account
	   (name "beebe")
	   (comment "Nelson H F Beebe")
	   (uid 887)
	   (group "users")
	   (home-directory "/u/sy/beebe")
	   (supplementary-groups '("wheel" "netdev" "audio" "video")))

	  (user-account
	   (name "bowman")
	   (comment "Pieter Bowman")
	   (uid 888)
	   (group "users")
	   (home-directory "/u/sy/bowman")
	   (supplementary-groups '("wheel" "netdev" "audio" "video")))

	  (user-account
	   (name "sysstaff")
	   (comment "System Staff")
	   (uid 810)
	   (group "users")
	   (home-directory "/u/sy/sysstaff")
	   (supplementary-groups '("wheel" "netdev" "audio" "video")))

          %base-user-accounts))

  (packages
    (list (specification->package "nss-certs")))

  (services
    (append
      (list (service xfce-desktop-service-type)
            (service openssh-service-type)
            (set-xorg-configuration
              (xorg-configuration
                (keyboard-layout keyboard-layout))))
      %desktop-services))
  )

-------------------------------------------------------------------------------
- Nelson H. F. Beebe                    Tel: +1 801 581 5254                  -
- University of Utah                    FAX: +1 801 581 4148                  -
- Department of Mathematics, 110 LCB    Internet e-mail: [email-masked]  -
- 155 S 1400 E RM 233                       [email-masked]  [email-masked] -
- Salt Lake City, UT 84112-0090, USA    URL: http://www.math.utah.edu/~beebe/ -
-------------------------------------------------------------------------------